CodeForces - 834D(80/600)

88 篇文章 0 订阅
7 篇文章 0 订阅

Some time ago Slastyona the Sweetmaid decided to open her own bakery! She bought required ingredients and a wonder-oven which can bake several types of cakes, and opened the bakery.

Soon the expenses started to overcome the income, so Slastyona decided to study the sweets market. She learned it’s profitable to pack cakes in boxes, and that the more distinct cake types a box contains (let’s denote this number as the value of the box), the higher price it has.

She needs to change the production technology! The problem is that the oven chooses the cake types on its own and Slastyona can’t affect it. However, she knows the types and order of n cakes the oven is going to bake today. Slastyona has to pack exactly k boxes with cakes today, and she has to put in each box several (at least one) cakes the oven produced one right after another (in other words, she has to put in a box a continuous segment of cakes).

Slastyona wants to maximize the total value of all boxes with cakes. Help her determine this maximum possible total value.

Input
The first line contains two integers n and k (1 ≤ n ≤ 35000, 1 ≤ k ≤ min(n, 50)) – the number of cakes and the number of boxes, respectively.

The second line contains n integers a1, a2, …, an (1 ≤ ai ≤ n) – the types of cakes in the order the oven bakes them.

Output
Print the only integer – the maximum total value of all boxes with cakes.

Example
Input
4 1
1 2 2 1
Output
2
Input
7 2
1 3 3 1 4 4 4
Output
5
Input
8 3
7 7 8 7 7 8 1 7
Output
6
Note
In the first example Slastyona has only one box. She has to put all cakes in it, so that there are two types of cakes in the box, so the value is equal to 2.

In the second example it is profitable to put the first two cakes in the first box, and all the rest in the second. There are two distinct types in the first box, and three in the second box then, so the total value is 5.

这个题首先掌握一个弱智的暴力n^2dp做法
然后加上线段树

这个线段树加的真鸡儿巧妙
首先枚举分块次数

然后对于每个次数
每种数不可能贡献超过分块次数的值

然后只有覆盖的区间内才享有贡献值
对于dp数组每一层只用一次线段树

每次用线段树覆盖前面相当于一个
dp+w()的比较
取最大的就是要更新的

因为前面都是更新好了的
所以后面不用更新了…

#include<cstdio>  
#include<algorithm>  
#include<iostream>
#include<cstring>  
using namespace std;
struct p
{
    int z, y, c,l;
};
p shu[300000];
int dp[300000],tu[300000];
void jianshu(int gen, int z, int y)
{
    shu[gen].z = z;
    shu[gen].y = y;
    shu[gen].l = shu[gen].c = 0;
    if (z == y)
    {
        shu[gen].c = dp[z];
        return;
    }
    int mid = (z + y) / 2;
    jianshu(2 * gen, z, mid);
    jianshu(2 * gen + 1, mid + 1, y);
    shu[gen].c = max(shu[2 * gen].c, shu[2 * gen + 1].c);
}
void gengxin(int gen, int z, int y, int l, int r,int zhi)
{
    if (z > r||y<l)return;
    if (z >= l&&y <= r)
    {
        shu[gen].c += zhi;
        shu[gen].l += zhi;
        return;
    }
    int mid = (z + y) / 2;
    shu[2 * gen].c += shu[gen].l;
    shu[2 * gen + 1].c += shu[gen].l;
    shu[2 * gen].l += shu[gen].l;
    shu[2 * gen + 1].l += shu[gen].l;
    shu[gen].l = 0;
    gengxin(2 * gen, z, mid, l, r, zhi);
    gengxin(2 * gen + 1, mid + 1, y, l, r, zhi);
    shu[gen].c = max(shu[gen*2].c, shu[gen * 2 + 1].c);
}
int wen(int gen, int z, int y, int l, int r)
{
    if (z > r || y < l)return 0;
    if (z >= l&&y <= r)return shu[gen].c;
    int mid = (z + y) / 2;
    shu[2 * gen].c += shu[gen].l;
    shu[2 * gen+1].c += shu[gen].l;
    shu[2 * gen].l += shu[gen].l;
    shu[2 * gen+1].l += shu[gen].l;
    shu[gen].l = 0;
    return max(wen(2 * gen, z, mid, l, r), wen(2 * gen + 1, mid + 1, y, l, r));
}
int zj[360000],sg[360000];
int main()
{
    int n, m;
    cin >> n >> m;
    for (int a = 1; a <= n; a++)scanf("%d", &tu[a]);
    for (int a = 1; a <= n; a++)
    {
        sg[a] = zj[tu[a]];
        zj[tu[a]] = a;
    }
//  for (int a = 1; a <= n; a++)cout << sg[a] << " ";
    //return 0;
    for (int a = 1; a <= m; a++)
    {
        jianshu(1, 0, n);
    //  for (int c = 0; c <= n; c++)cout << dp[c] << " ";
    //  cout << endl;
        for (int b = 1; b <= n; b++)
        {
            gengxin(1, 0, n, sg[b], b - 1, 1);
            dp[b] = wen(1, 0, n, 0, b-1);
        }
    //  for (int c = 0; c <= n; c++)cout << wen(1, 0, n, c, c) << " ";
//      cout << endl;//
    }
    printf("%d\n", dp[n]);
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值